package codechicken.enderstorage.api;

import net.minecraft.nbt.NBTTagCompound;

public abstract class AbstractEnderStorage
{
    public final EnderStorageManager manager;
    public final int freq;
    public final String owner;
    private boolean dirty;
    
    public AbstractEnderStorage(EnderStorageManager manager, String owner, int freq)
    {
        this.manager = manager;
        this.owner = owner;
        this.freq = freq;
    }
    
    public void setDirty()
    {
        if(!dirty && !manager.client)
        {
            dirty = true;
            manager.requestSave(this);
        }
    }
    
    public void setClean()
    {
        dirty = false;
    }
    
    public abstract String type();

    public abstract NBTTagCompound saveToTag();
    
    public abstract void loadFromTag(NBTTagCompound tag);
}