package codechicken.enderstorage.internal;

import codechicken.core.packet.PacketCustom;
import codechicken.enderstorage.EnderStorage;
import codechicken.enderstorage.common.ItemEnderStorageRenderer;
import codechicken.enderstorage.storage.item.TileEnderChest;
import codechicken.enderstorage.storage.item.EnderChestRenderer;
import codechicken.enderstorage.storage.liquid.TileEnderTank;
import codechicken.enderstorage.storage.liquid.EnderTankRenderer;
import net.minecraftforge.client.MinecraftForgeClient;
import cpw.mods.fml.client.registry.ClientRegistry;

public class EnderStorageClientProxy extends EnderStorageProxy
{	
	@Override
	public void load()
	{
		super.load();
        PacketCustom.assignHandler(EnderStorageCPH.channel, 0, 255, new EnderStorageCPH());

        MinecraftForgeClient.registerItemRenderer(EnderStorage.blockEnderChest.blockID, new ItemEnderStorageRenderer());

        ClientRegistry.bindTileEntitySpecialRenderer(TileEnderChest.class, new EnderChestRenderer());
        ClientRegistry.bindTileEntitySpecialRenderer(TileEnderTank.class, new EnderTankRenderer());
        
        //MinecraftForgeClient.registerItemRenderer(EnderStorage.itemEnderPouch.shiftedIndex, new ItemEnderPouchRenderer());
	}
	
	public static float getPearlBob(double time)
	{
        return (float) Math.sin(time/25*3.141593) * 0.1F;
	}

    public static int getTimeOffset(int x, int y, int z)
    {
        return x*3+y*5+z*9;
    }
}
