package codechicken.enderstorage.internal;

import net.minecraft.item.ItemStack;
import net.minecraftforge.common.MinecraftForge;
import codechicken.core.CommonUtils;
import codechicken.core.packet.PacketCustom;
import codechicken.enderstorage.api.EnderStorageManager.EnderStoragePlayerTracker;
import codechicken.enderstorage.common.BlockEnderStorage;
import codechicken.enderstorage.common.EnderStorageRecipe;
import codechicken.enderstorage.common.ItemEnderStorage;
import codechicken.enderstorage.storage.item.ItemEnderPouch;
import codechicken.enderstorage.storage.item.TileEnderChest;
import codechicken.enderstorage.storage.liquid.TankSynchroniser;
import codechicken.enderstorage.storage.liquid.TileEnderTank;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.common.registry.LanguageRegistry;
import cpw.mods.fml.common.registry.TickRegistry;
import cpw.mods.fml.relauncher.Side;

import static codechicken.enderstorage.EnderStorage.*;

public class EnderStorageProxy
{	
	public void load()
	{
		blockEnderChest = new BlockEnderStorage(config.getTag("block.id").getIntValue(CommonUtils.getFreeBlockID(241)));
		blockEnderChest.setBlockName("enderchest");
        MinecraftForge.EVENT_BUS.register(blockEnderChest);
        
        GameRegistry.registerBlock(blockEnderChest, ItemEnderStorage.class, "enderChest");
        LanguageRegistry.addName(new ItemStack(blockEnderChest, 1, 0), "Ender Chest");
        LanguageRegistry.addName(new ItemStack(blockEnderChest, 1, 0x1000), "Ender Tank");
        
        GameRegistry.registerTileEntity(TileEnderChest.class, "Ender Chest");
        GameRegistry.registerTileEntity(TileEnderTank.class, "Ender Tank");
        
		itemEnderPouch = new ItemEnderPouch(config.getTag("pouch.id").getIntValue(7237));
		itemEnderPouch.setItemName("enderpouch");
        LanguageRegistry.addName(itemEnderPouch, "Ender Pouch");
        
        PacketCustom.assignHandler(EnderStorageSPH.channel, 0, 255, new EnderStorageSPH());
        EnderStorageRecipe.init();
        
        GameRegistry.registerPlayerTracker(new EnderStoragePlayerTracker());
        GameRegistry.registerPlayerTracker(new TankSynchroniser());
        TickRegistry.registerTickHandler(new TankSynchroniser(), Side.CLIENT);
        TickRegistry.registerTickHandler(new TankSynchroniser(), Side.SERVER);
	}
}
