package codechicken.enderstorage.storage.item;

import org.lwjgl.opengl.GL11;

import codechicken.enderstorage.storage.item.ContainerEnderItemStorage;
import net.minecraft.client.gui.inventory.GuiContainer;
import net.minecraft.inventory.IInventory;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.util.StatCollector;

public class GuiEnderItemStorage extends GuiContainer
{
	private String name;
    private IInventory playerInv;
    private EnderItemStorage chestInv;

    public GuiEnderItemStorage(InventoryPlayer invplayer, EnderItemStorage chestInv, String name)
	{
        super(new ContainerEnderItemStorage(invplayer, chestInv, true));
        playerInv = invplayer;
        this.chestInv = chestInv;
        allowUserInput = false;
        this.name = name;
        
        if(chestInv.getSize() == 2)
            ySize = 222;
	}

    @Override
    protected void drawGuiContainerForegroundLayer(int par1, int par2)
    {
        fontRenderer.drawString(name, 8, 6, 0x404040);
        fontRenderer.drawString(StatCollector.translateToLocal(playerInv.getInvName()), 8, ySize - 94, 0x404040);
        ContainerEnderItemStorage ces = (ContainerEnderItemStorage)inventorySlots;
        if(!ces.chestInv.owner.equals("global"))
            fontRenderer.drawString(ces.chestInv.owner, 170-fontRenderer.getStringWidth(ces.chestInv.owner), 6, 0x404040);
    }
	
    protected void drawGuiContainerBackgroundLayer(float f, int i, int j)
    {
        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
        mc.renderEngine.bindTexture(mc.renderEngine.getTexture(chestInv.getSize() == 0 ? "/gui/trap.png" : "/gui/container.png"));
        int x = (width - xSize) / 2;
        int y = (height - ySize) / 2;
        
        switch(chestInv.getSize())
        {
            case 0:
            case 2:
                drawTexturedModalRect(x, y, 0, 0, xSize, ySize);
                break;
            case 1:
                drawTexturedModalRect(x, y, 0, 0, xSize, 71);
                drawTexturedModalRect(x, y+71, 0, 126, xSize, 96);
                break;
                
        }
    }
}
