package codechicken.enderstorage.storage.item;

import java.util.List;

import codechicken.enderstorage.api.EnderStorageManager;
import codechicken.enderstorage.storage.EnderItemStoragePlugin;

import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.world.World;

public class ItemEnderPouch extends Item
{
	public ItemEnderPouch(int ID)
	{
		super(ID);
		setMaxStackSize(1);
		setHasSubtypes(true);
        setCreativeTab(CreativeTabs.tabDecorations);
	}
	
	@SuppressWarnings({"unchecked", "rawtypes"})
	@Override
	public void addInformation(ItemStack stack, EntityPlayer player, List list, boolean extended)
	{
		if(stack.hasTagCompound() && !stack.getTagCompound().getString("owner").equals("global"))
			list.add(stack.getTagCompound().getString("owner"));
	}
	
	@Override
	public boolean onItemUseFirst(ItemStack stack, EntityPlayer player, World world, int x, int y, int z, int side, float hitX, float hitY, float hitZ)
	{
		if(world.isRemote)
			return false;
		
		TileEntity tile = world.getBlockTileEntity(x, y, z);
		if(tile instanceof TileEnderChest && player.isSneaking())
		{
			TileEnderChest chest = (TileEnderChest)tile;
			stack.setItemDamage(chest.freq | (chest.owner.equals("global") ? 0 : 0x2000));
			if(!stack.hasTagCompound())
			    stack.setTagCompound(new NBTTagCompound());
			stack.getTagCompound().setString("owner", chest.owner);
			return true;
		}
		return false;
	}
	
	@Override
	public ItemStack onItemRightClick(ItemStack item, World world, EntityPlayer player)
	{
    	if(world.isRemote || player.isSneaking())
    		return item;
    	
        ((EnderItemStorage) EnderStorageManager.instance(world.isRemote)
                .getStorage(item.hasTagCompound() ? item.getTagCompound().getString("owner") : "global", item.getItemDamage() & 0xFFF, "item"))
                .openSMPGui(player, "Ender Pouch");
    	return item;
	}
	
	public boolean func_46058_c()
	{
		return true;
	}
	
	@Override
	public int getRenderPasses(int metadata)
	{
		return 4;
	}
	
	public int getIconFromDamageForRenderPass(int damage, int renderPass)
	{
		if(renderPass == 0)
			return (damage & 0x2000) == 0 ? 0 : 2;
		
		return renderPass*16+EnderStorageManager.getColourFromFreq(damage, renderPass-1);
	}
	
	public boolean requiresMultipleRenderPasses()
	{
		return true;
	}
	
	@Override
	public String getTextureFile()
	{
		return "/codechicken/enderstorage/gfx/enderpouch.png";
	}
}
